lens-action-0.2.4: Monadic Getters and Folds

Copyright | (C) 2012-14 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable
Safe Haskell | None
Language | Haskell98

Control.Lens.Action.Reified

Description

Synopsis

- newtype ReifiedMonadicFold m s a = MonadicFold {
  - runMonadicFold :: MonadicFold m s a
  }

# Documentation

newtype ReifiedMonadicFold m s a Source #

Reify a `MonadicFold` so it can be stored safely in a container.

Constructors

MonadicFold |

Fields

- runMonadicFold :: MonadicFold m s a

#### Instances

Instances details

MonadReader s (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods ask :: ReifiedMonadicFold m s s local :: (s -> s) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a reader :: (s -> a) -> ReifiedMonadicFold m s a
Arrow (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

arr :: (b -> c) -> ReifiedMonadicFold m b c

first :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (b, d) (c, d)

second :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (d, b) (d, c)

(***) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b' c' -> ReifiedMonadicFold m (b, b') (c, c')

(&&&) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b c' -> ReifiedMonadicFold m b (c, c')

Profunctor (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

dimap :: (a -> b) -> (c -> d) -> ReifiedMonadicFold m b c -> ReifiedMonadicFold m a d Source #

lmap :: (a -> b) -> ReifiedMonadicFold m b c -> ReifiedMonadicFold m a c Source #

rmap :: (b -> c) -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c Source #

(#.) :: forall a b c q. Coercible c b => q b c -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c Source #

(.#) :: forall a b c q. Coercible b a => ReifiedMonadicFold m b c -> q a b -> ReifiedMonadicFold m a c Source #

Choice (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods left' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (Either a c) (Either b c) Source # right' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (Either c a) (Either c b) Source #
Strong (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods first' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (a, c) (b, c) Source # second' :: ReifiedMonadicFold m a b -> ReifiedMonadicFold m (c, a) (c, b) Source #
ArrowApply (ReifiedMonadicFold m) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods app :: ReifiedMonadicFold m (ReifiedMonadicFold m b c, b) c
ArrowChoice (ReifiedMonadicFold m) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

left :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (Either b d) (Either c d)

right :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m (Either d b) (Either d c)

(+++) :: ReifiedMonadicFold m b c -> ReifiedMonadicFold m b' c' -> ReifiedMonadicFold m (Either b b') (Either c c')

(|||) :: ReifiedMonadicFold m b d -> ReifiedMonadicFold m c d -> ReifiedMonadicFold m (Either b c) d

Category (ReifiedMonadicFold m :: Type -> Type -> Type) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods id :: forall (a :: k). ReifiedMonadicFold m a a (.) :: forall (b :: k) (c :: k) (a :: k). ReifiedMonadicFold m b c -> ReifiedMonadicFold m a b -> ReifiedMonadicFold m a c
Monad (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (>>=) :: ReifiedMonadicFold m s a -> (a -> ReifiedMonadicFold m s b) -> ReifiedMonadicFold m s b (>>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b return :: a -> ReifiedMonadicFold m s a
Functor (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods fmap :: (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b # (<$) :: a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a #
Applicative (ReifiedMonadicFold m s) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

pure :: a -> ReifiedMonadicFold m s a

(<*>) :: ReifiedMonadicFold m s (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b

liftA2 :: (a -> b -> c) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s c

(*>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b

(<*) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a

Alternative (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods empty :: ReifiedMonadicFold m s a (<|>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a some :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] many :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a]
MonadPlus (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods mzero :: ReifiedMonadicFold m s a mplus :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a
Apply (ReifiedMonadicFold m s) Source # |

Instance details

Defined in Control.Lens.Action.Reified

Methods

(<.>) :: ReifiedMonadicFold m s (a -> b) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b Source #

(.>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s b Source #

(<.) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s a Source #

liftF2 :: (a -> b -> c) -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s b -> ReifiedMonadicFold m s c Source #

Plus (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods zero :: ReifiedMonadicFold m s a Source #
Alt (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (<!>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a Source # some :: Applicative (ReifiedMonadicFold m s) => ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source # many :: Applicative (ReifiedMonadicFold m s) => ReifiedMonadicFold m s a -> ReifiedMonadicFold m s [a] Source #
Bind (ReifiedMonadicFold m s) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (>>-) :: ReifiedMonadicFold m s a -> (a -> ReifiedMonadicFold m s b) -> ReifiedMonadicFold m s b Source # join :: ReifiedMonadicFold m s (ReifiedMonadicFold m s a) -> ReifiedMonadicFold m s a Source #
Semigroup (ReifiedMonadicFold m s a) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods (<>) :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a sconcat :: NonEmpty (ReifiedMonadicFold m s a) -> ReifiedMonadicFold m s a stimes :: Integral b => b -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a
Monoid (ReifiedMonadicFold m s a) Source # |
Instance details Defined in Control.Lens.Action.Reified Methods mempty :: ReifiedMonadicFold m s a mappend :: ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a -> ReifiedMonadicFold m s a mconcat :: [ReifiedMonadicFold m s a] -> ReifiedMonadicFold m s a